/*
 *	MlpDeclaration.h
 *	version1.9.1
 */
/*
Copyright(c)ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	MLP_DECLARATION_H
#define	MLP_DECLARATION_H

typedef enum MlpPictureOpt {
	MLP_PICTURE_RGB,
	MLP_PICTURE_GRAY,
	MLP_PICTURE_DITHER,
	MLP_PICTURE_BW,
	MLP_PICTURE_FAXG3,
	MLP_PICTURE_FAXG4,

	MLP_COMPRESS_NONE,		/*TIFFϊ̏ꍇɈkȂ*/
	MLP_COMPRESS_JPEG,		/*TIFFϊ̏ꍇJPEGk*/
	MLP_COMPRESS_DEFLATE,	/*TIFFϊ̏ꍇDeflatek*/
	MLP_COMPRESS_LZW,		/*TIFFϊ̏ꍇLZWk*/

	MLP_JPEG_QUALITY,		/*JPEGk̉摜i*/

	MLP_RESOLUTION_DPI,					/*XDPI,YDPIol̉𑜓x*/
	MLP_RESOLUTION_XDPI,				/*XDPI 𑜓x*/
	MLP_RESOLUTION_YDPI,				/*YDPI 𑜓x*/
	MLP_CANVAS_SIZE,					/*LoXTCY XYow*/
	MLP_CANVAS_XSIZE,					/*LoXTCY X-݂̂w*/
	MLP_CANVAS_YSIZE,					/*LoXTCY Y-݂̂w*/
	MLP_PICTURE_XSIZE,					/*_TCYw*/
	MLP_PICTURE_YSIZE,					/*_TCYw*/
	MLP_PICTURE_SIZE_UNIT,				/*_TCY̒P*/
	MLP_PICTURE_USE_MEDIABOX,			/*y[W̋EMediaBoxɂ*/
	MLP_PICTURE_USE_CROPBOX,			/*y[W̋ECropBoxɂ*/
	MLP_PICTURE_USE_BLEEDBOX,			/*y[W̋EBleedBoxɂ*/
	MLP_PICTURE_USE_TRIMBOX,			/*y[W̋ETrimBoxɂ*/
	MLP_PICTURE_USE_ARTBOX,				/*y[W̋EArtBoxɂ*/
	MLP_PIXEL_SIZE_X,					/*sNZPʂ̉摜*/
	MLP_PIXEL_SIZE_Y,					/*sNZPʂ̉摜*/
	MLP_FILL_PATH_AA,					/*tBpX̃A`ACAX*/
	MLP_NOT_DEF_GLYPH,					/*R[h0̃Ot 0:notdef\, 1:(gid=0)\, 2:̕𖳎*/
	MLP_CID_0_GLYPH=28,					/*MLP_NOT_DEF_GLYPH̕ʖ*/
	MLP_TRUNCATE_PAGE_BBOX,				/*y[WE𐮐ۂɏ؂̂ď(MediaBox̏ꍇ)*/
	MLP_PAGE_CLIP_VALUE,				/*y[Ẅ̗wlsNZȗ̈ŃNbv*/
	MLP_STROKEPATH_MINIMUM_LINE_WIDTH,	/*pX̃Xg[Nɂŏw*/

	MLP_THRESHOLD_BITONAL,				/*l臒l*/
	MLP_THRESHOLD_DITHER,				/*fBU臒l*/

	MLP_PICTURE_CMYK=36,				/*CMYKF*/
	MLP_ANTIALIAS_LEVEL,				/*A`ACAX̃x*/
	MLP_DATA_COMPRESSION_LEVEL,			/*f[^k̃x*/
	MLP_PICTURE_USE_MEDIA_CROP=43,		/*y[W̋EMediaBox܂CropBox̏ɂ*/
	MLP_OCG_USAGE=44,					/*0:"view", 1:"Print", 2:"Export"*/
	MLP_TEXT_ANTIALIAS,					/*1:eLXg̃A`ACAXL()A0:*/
	MLP_XY_PIXEL_SIZE_MEM=47,			/*oオ摜f[^̕TCY (cłꂼDPIɐݒ肳)*/
	MLP_REPLACE_TR2_MODE,				/*eLXgFill then Stroke`ύX 0:]ǂA1:Fill`A2:Stroke`*/

	MLP_STROKEPATH_ENABLE_CALLBACK=1001,/*Xg[NpX̃R[obNLɂ*/
	MLP_TILE_IMAGE_ENABLE_CALLBACK,		/*^C摜̃R[obNLɂ*/
	MLP_TILE_MASK_IMG_ENABLE_CALLBACK,	/*^C}XN摜̃R[obNLɂ*/
	MLP_TILING_ENABLE_CALLBACK,			/*^CÕR[obNLɂ*/
	MLP_TILING_IGNORE_PROCESS,			/*^COSɖ(̋@\͔T|[g)*/
	MLP_SUPPRESS_ALPHA_CHANNEL_ON_CB,	/*R[obN̉摜f[^ɃAt@`ll܂߂Ȃ*/
} MlpPictureOpt;

typedef enum MlpDocumentOpt {
	MLP_PERMISSION_FLAG = 1201,		/*̃p[~bVtO*/
	MLP_OCG_COUNT,					/*OCG̑*/
	MLP_GLYPH_NOT_FOUND_COUNT,		/*OtłȂ*/
	MLP_PDF_AUTHOR,
	MLP_NEEDS_PASSWORD = 1205,		/*0:ÍA1:NULLpX[hŃI[vA2:pX[hKv*/
	MLP_OCG_PROPERTY,				/*OCGvpeB*/
	MLP_PRINT_RESTRICTION,			/*ꂽ𑜓xtOl 1:肳ꂽ(𑜓x)A0:(𑜓x)*/
} MlpDocumentOpt;

typedef enum MlpLibraryOpt {
	MLP_LOGICAL_CPU_COUNT=101,		/*_ICPȖ*/
	MLP_THREAD_SPLIT_PAGE=102,		/*y[W𕡐̃XbhŎs*/
	MLP_THREAD_SPLIT_PAGE_COUNT,	/*y[W𕪊Xbh̐*/
	MLP_THREAD_EACH_PAGE,			/*ey[Wʂ̃XbhŎs*/
	MLP_THREAD_EACH_PAGE_COUNT,		/*iy[WXbh̐*/

	MLP_LICENSE_ERROR_INFO = 1201,	/*sCZX̏ڍ׏*/
} MlpLibraryOpt;

typedef enum MlpCallbackSettingMode {
	MLP_RENDERING_CB=1,				/*y[W̉͏I / _O̊Jnm点R[obNw*/
	MLP_PROGRESS_CB,				/*w肵s̃_Oi摜i[jIƂm点R[obNw*/
	MLP_RENDERED_CB,				/*y[W̃_OIm点R[obNw*/

	MLP_DRAW_STROKE_PATH_CB=101,	/*pX̃Xg[LOƂɃR[obN*/
	MLP_DEFINE_IMAGE_TILE_CB,		/*^C`ꂽƂɃR[obN*/
	MLP_DEFINE_MASK_IMAGE_TILE_CB,	/*^C̃}XN`ꂽƂɃR[obN*/
	MLP_DRAW_TILED_IMAGE_CB,		/*^COꂽ摜\tƂɃR[obN*/
} MlpCallbackSettingMode;

typedef enum MlpTiffCompressMode {
	MLP_TIFF_COMPRESS_NONE=0,		/*TIFFϊňkȂ*/
	MLP_TIFF_COMPRESS_JPEG,			/*TIFFϊJPEGk*/
	MLP_TIFF_COMPRESS_DEFLATE,		/*TIFFϊDeflatek*/
	MLP_TIFF_COMPRESS_LZW,			/*TIFFϊLZWk*/
} MlpTiffComtressMode;

typedef enum MlpConstants {
	MIN_RESOLUTION		= 50,
	MAX_RESOLUTION		= 10000,
	DEFAULT_RESOLUTION	= 150,
	MIN_QUALITY			= 10,
	MAX_QUALITY			= 90,
	MIN_PICT_BUF_SIZE	= 50,	/*50MBȏ*/
	MAX_PICT_BUF_SIZE	= 1024,	/*PGBȉ*/
	MIN_PIXEL_SIZE		= 200,
	MAX_PIXEL_SIZE		= 5000000,
} MlpConstants;

typedef enum MlpCid0GlyphMode {
	SHOW_NOTDEF_GLYPH		= 0,
	REPLACE_TO_BLANK_GLYPH	= 1,
	IGNORE_CID_0_GLYPH		= 2,
} MlpCid0GlyphMode;

typedef enum MlpBoundaryBox {
	MEDIA_BOX		=0,
	CROP_BOX		=1,
	BLEED_BOX		=2,
	TRIM_BOX		=3,
	ART_BOX			=4,
} MlpBoundaryBox;

#define	MAX_OCG_NAME_LEN	100

typedef	struct MlpOcgDataRec_s MlpOcgDataRec_t;
typedef	struct MlpOcgUsageRec_s MlpOcgUsageRec_t;
typedef	MlpOcgDataRec_t	MlpOcgData;
typedef	MlpOcgUsageRec_t	MlpOcgUsage;

struct MlpOcgDataRec_s {
	int		id;
	char	name[MAX_OCG_NAME_LEN+1];
	int		level;
	int		visible;
} ;

struct MlpOcgUsageRec_s {
	int		id;
	char	name[MAX_OCG_NAME_LEN+1];
	int		level;
	int		visible;
	/*Usage*/
	int	printState;
	int	viewState;
} ;

typedef	struct OcgInfoRec_s {
	size_t	size;
	struct {
		char	*Creator;
		char	*Subtype;
	}	CreatorInfo;
	struct {
		char	*Lang;
		char	*Preferred;
	}	Language;
	struct {
		char	*ExportState;
	}	Export;
	struct {
		int		min, max;
	}	Zoom;
	struct {
		char	*Subtype;
		char	*PrintState;
	}	Print;
	struct {
		char	*ViewState;
	}	View;
	struct {
		char	*Type;
		char	*Name;
	}	User;
	struct {
		char	*Subtype;
	}	PageElement;
} MlpOcgInfoRec;

typedef struct StrokePathAttr_s {
	float	lineWidth;
	int		lineCap;
	int		lineJoin;
	float	miterLimit;

	int		dashLen;
	float	dashPhase;
	float	dashData[32];

	float	colorfv[5];

	char	*pathString;

	int		x, y, width, height;
	int		colors;
} StrokePathAttr;

typedef	struct Matrix_s {
	float	a, b, c, d, e, f;
} Matrix;

typedef struct ImageTileAttr_s {
	int		width, height, colors;
	float	xstep, ystep;
	Matrix	ctm;
} ImageTileAttr;

/*
 *	͗p
 */

typedef	struct PrsFontName_s PrsFontName;

struct PrsFontName_s {
	int		pageNum;		/*tHggĂy[Wԍ*/
	char	fontId[256];	/*tHg̎ʖ*/
	char	fontName[256];	/*tHg*/
	int		embedded;		/*1:ߍ܂ꂽtHgA0:ȊO*/
	int		render;			/*-1:_[[h̎w肪ȂA0:ʏ̃_[[hŗpĂA1:Tr=2̃_[[hŎgpĂ*/
};

#endif	/*MLP_DECLARATION_H*/
