﻿/*
Copyright(c) 2017 株式会社トラスト・ソフトウェア・システム
無断転載を禁止します。
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ImagerApp
{
	public partial class ColorprofileDlg : Form
	{
		public string rgbProfile;
		public string cmykProfile;
		public int conv;

		public ColorprofileDlg()
		{
			InitializeComponent();
			rgbProfile = rgbCb.Items[0].ToString();
			cmykProfile = cmykCb.Items[0].ToString();
			conv = 2;
		}

		private void ColorprofileDlg_Load(object sender, EventArgs e)
		{
			rgbCb.Text = rgbCb.Items[0].ToString();
			cmykCb.Text = cmykCb.Items[0].ToString();
		}

		//RGBカラープロファイルが変更された
		private void rgbCB_SelectedIndexChanged(object sender, EventArgs e)
		{
		}

		private void ColorprofileDlg_Shown(object sender, EventArgs e)
		{
			switch (conv)
			{
				case 1:
					mostFastConvRb.Checked = true;
					break;
				case 2:
					fastConvRb.Checked = true;
					break;
				case 3:
					break;
				default:
					fastConvRb.Checked = true;
					conv = 2;
					break;
			}
		}

		private void OKBtn_Click(object sender, EventArgs e)
		{
			string[] d = {"  -  "};
			if (mostFastConvRb.Checked) conv = 1;
			else if (fastConvRb.Checked) conv = 2;
			else if (colorprofileConvRb.Checked) conv = 3;
			else conv = 2;
			rgbProfile = rgbCb.Text.Split(d, StringSplitOptions.None)[0];
			cmykProfile = cmykCb.Text.Split(d, StringSplitOptions.None)[0];
		}
	}
}
